    global AT91C_EBI_SDRAM AT91C_CCFG_EBICSA AT91C_EBI_CS1A
    global AT91C_SDRAMC_CR AT91C_SDRAMC_TXSR_9 AT91C_SDRAMC_TRAS_6 AT91C_SDRAMC_TRCD_3 
    global AT91C_SDRAMC_TRC_8 AT91C_SDRAMC_TWR_3 AT91C_SDRAMC_TRP_3
    global AT91C_SDRAMC_CAS_2 AT91C_SDRAMC_DBW_32_BITS AT91C_SDRAMC_NC_9 AT91C_SDRAMC_NR_13 AT91C_SDRAMC_NB_4_BANKS
    global AT91C_SDRAMC_MR AT91C_SDRAMC_MODE_PRCGALL_CMD AT91C_SDRAMC_MODE_RFSH_CMD 
    global AT91C_SDRAMC_MODE_LMR_CMD AT91C_SDRAMC_MODE_NORMAL_CMD
    global AT91C_SDRAMC_TR AT91C_SDRAMC_COUNT
    global AT91C_PIOC_ASR AT91C_PIOC_BSR AT91C_PIOC_PDR
    
    puts "-I- Configure PIOC as peripheral (D16/D31)"
    # PIOC16 to 31
    set register_value 0xFFFF0000
    # AT91F_PIO_CfgPeriph
    write_int    $AT91C_PIOC_ASR    $register_value
    write_int    $AT91C_PIOC_BSR    0
    # Set in Periph mode
    write_int    $AT91C_PIOC_PDR    [expr $register_value | 0]

    puts "-I- Init MATRIX to support CS1 for SDRAM"
    set register_value     [expr [read_int $AT91C_CCFG_EBICSA] | $AT91C_EBI_CS1A]
    write_int            $AT91C_CCFG_EBICSA  $register_value
        
    puts "-I- Init SDRAM"
    puts "-I- 1. A minimum pause of 200us is provided to precede any signal toggle"
    set register_value     [expr $AT91C_SDRAMC_TXSR_9 | $AT91C_SDRAMC_TRAS_6 | $AT91C_SDRAMC_TRCD_3 | $AT91C_SDRAMC_TRP_3 | $AT91C_SDRAMC_TRC_8 | $AT91C_SDRAMC_TWR_3]
    set register_value     [expr $register_value | $AT91C_SDRAMC_NC_9 | $AT91C_SDRAMC_NR_13 | $AT91C_SDRAMC_NB_4_BANKS | $AT91C_SDRAMC_CAS_2 | $AT91C_SDRAMC_DBW_32_BITS]
    write_int            $AT91C_SDRAMC_CR   $register_value

    puts "-I- 2. A Precharge All command is issued to the SDRAM"
    write_int            $AT91C_SDRAMC_MR  $AT91C_SDRAMC_MODE_PRCGALL_CMD
    puts "-I- *pSDRAM = 0;"
    write_int            $AT91C_EBI_SDRAM  0
    
    puts "-I- 3. Eight Auto-refresh are provided"
    write_int           $AT91C_SDRAMC_MR  $AT91C_SDRAMC_MODE_RFSH_CMD
    for {set i 0} {$i<8} {incr i} {
        puts "-I- *pSDRAM = 0;"
        write_int    $AT91C_EBI_SDRAM  0
    }
    
    puts "-I- 4. A mode register cycle is issued to program the SDRAM parameters"
    write_int           $AT91C_SDRAMC_MR  $AT91C_SDRAMC_MODE_LMR_CMD
    puts "-I- *(pSDRAM+0x20) = 0;"
    write_int           [expr $AT91C_EBI_SDRAM + 0x20]  0xcafedede
    
    puts "-I- 5. Write refresh rate into SDRAMC refresh timer COUNT register"
    write_int           $AT91C_SDRAMC_TR [expr $AT91C_SDRAMC_COUNT & 0x3a3]

    puts "-I- 6. A Normal Mode Command is provided, 3 clocks after tMRD is set"
    write_int           $AT91C_SDRAMC_MR $AT91C_SDRAMC_MODE_NORMAL_CMD
    puts "-I- *pSDRAM = 0;"
    write_int            $AT91C_EBI_SDRAM  0   

puts "-I- End of Init_SDRAM133"


