#ifndef _PLAYER_H_
#define _PLAYER_H_

/*
 * Copyright (C) 2003-2006 by egnite Software GmbH. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
 * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.ethernut.de/
 */

/*!
 * \file mp3player.h
 * \brief MP3 Player.
 *
 * \verbatim
 *
 * $Log$
 *
 * \endverbatim
 */

#include <sys/socket.h>
#include <hxmp3/mp3dec.h>
#include "receiver.h"

#define PSTAT_IDLE      0
#define PSTAT_START     1
#define PSTAT_RUNNING   2
#define PSTAT_STOP      3

#define PLAYER_TYPE_MP3     1

typedef struct {
    u_int  pi_status;
    HANDLE pi_tid;
    HANDLE pi_cmdevt;
    HANDLE pi_stsevt;
    short pi_pcmbuf[MAX_NCHAN * MAX_NGRAN * MAX_NSAMP];
    HMP3Decoder pi_mp3dec;
    MP3FrameInfo pi_frameinfo;
    RECEIVERINFO *pi_rcvr;
} PLAYERINFO;

__BEGIN_DECLS
/* Prototypes */

extern PLAYERINFO * PlayerCreate(u_int type);
extern u_int PlayerThreadStatus(PLAYERINFO *pip);
extern int PlayerStart(PLAYERINFO *pip, RECEIVERINFO *rip);
extern int PlayerStop(PLAYERINFO *pip);

__END_DECLS
/* End of prototypes */
#endif
